<template>
  <form @submit.prevent="tryLogin" novalidate>
    <page-title class="title" :title="'Aanmelden'"></page-title>
    <FormField id="email"
               v-model="email"
               type="email"
               :required="true"
               label="Email"
               :error="emailError"></FormField>
    <FormField id="password"
               v-model="password"
               type="password"
               :required="true"
               label="Wachtwoord"
               :error="passwordError"></FormField>
    <button type="submit">Inloggen</button>

    <div class="a">
      <p>Heb je nog geen accound? &nbsp;
        <router-link :to="{name: 'Register'}">Registreren</router-link>
      </p>
    </div>
    <div class="loading" v-show="loading" role="alert">
      <loading></loading>
    </div>
    <Error v-if="error" :value="error"></Error>
  </form>
</template>

<script>

import FormField from '@/components/UI/molecules/FormField.vue';
import Error from '@/components/UI/atoms/Error.vue';
import PageTitle from '@/components/UI/atoms/PageTitle.vue';

import { mapActions } from 'vuex';

import Loading from '@/components/UI/atoms/Loading.vue';

const emailRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export default {
  name: 'LoginForm',
  components: {
    Loading,
    PageTitle,
    FormField,
    Error,
  },
  data() {
    return {
      email: null,
      password: null,
      error: null,
      loading: false,
      submitted: false,
    };
  },
  computed: {
    emailError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.email) {
        return 'Email is een verplicht veld.';
      }
      if (!emailRegex.test(this.email)) {
        return 'Geef een geldige Email';
      }
      return null;
    },
    passwordError() {
      if (!this.submitted) {
        return null;
      }
      if (!this.password) {
        return 'Wachtwoord is een verplicht veld.';
      }
      return null;
    },
    hasErrors() {
      return this.emailError || this.passwordError;
    },
  },
  methods: {
    ...mapActions('auth', ['logIn']),
    async tryLogin() {
      this.submitted = true;
      if (this.hasErrors) {
        return;
      }
      this.loading = true;
      try {
        await this.logIn({
          email: this.email,
          password: this.password,
        });
      } catch (e) {
        if (e.response.status === 422) {
          this.error = 'E-mail of wachtwoord is niet correct.';
          return;
        }
        this.error = 'Er is een onverwachte fout opgetreden.';
      } finally {
        await this.$store.dispatch('trajectories/getTrajectories');
        await this.$router.push(this.$route.query.redirect || '/trajecten');
        // await this.$router.push({ name: 'Trajectories' });
        this.loading = false;
      }
    },
  },
};
</script>

<style scoped lang="scss">
  form{
    max-width: 320px;
  }
  .title{
    font-size: 4em;
  }
  button{
    width: 120px;
    height: 42px;
    font-family: 'Roboto', sans-serif;
    font-size: 20px;
    border: none;
    border-radius: 6px;
    background-color: $custom_red;
    color: #FFFFFF;
    margin-top: 30px;
  }
  button:hover{
    opacity: 0.8;
  }
  .loading{
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: rgba(1, 1, 1, 0.2);
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
  p{
    font-family: 'Roboto', sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 1.6em;
    line-height: 24px;
    color: $custom_gray;
    margin-bottom: 30px;
  };
  div.a{
    margin: 40px 0;
  }
  a{
    text-decoration: none;
    font-family: 'Roboto', sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 18px;
    color: $custom_red;
  }
  a:hover{
    opacity: 0.7;
  }
</style>
